Index: /trunk/LMDZ.GENERIC/makegcm_ifort
===================================================================
--- /trunk/LMDZ.GENERIC/makegcm_ifort	(revision 252)
+++ /trunk/LMDZ.GENERIC/makegcm_ifort	(revision 253)
@@ -13,5 +13,5 @@
 set grille=reg
 set dyntype="dyn"
-set bands="8x7"
+set bands="32x36"
 ########################################################################
 # path a changer contenant les sources et les objets du modele
@@ -324,10 +324,9 @@
 ########################################################################
 
-    case -d:
+    case -d
         set dim=$2 ; shift ; shift ; goto top
                         
     case -O:
-#        set optim90="$2" ; set optimtru90="$2" ; shift ; shift ; goto top
-        set optim90="$2" ; optim="$2" ; optimtru90="$2" ; shift ; shift ; goto top
+        set optim90="$2" ; set optim="$2" ; set optimtru90="$2" ; shift ; shift ; goto top
 
      case -p
@@ -368,7 +367,7 @@
            set optim90="$optim90"" -G1 "
         else if $LINUX then
-	   set optim=" -g -no-ftz -traceback -ftrapuv -fp-stack-check "
-           set optim90=" -g -no-ftz -traceback -ftrapuv -fp-stack-check "
-           set optimtru90=" -g -no-ftz -traceback -ftrapuv -fp-stack-check "
+	   set optim=" -g -no-ftz -traceback -ftrapuv -fp-stack-check -check"
+           set optim90=" -g -no-ftz -traceback -ftrapuv -fp-stack-check -check"
+           set optimtru90=" -g -no-ftz -traceback -ftrapuv -fp-stack-check -check"
         else 
            echo "pas d option debug predefinie pour cette machine"
@@ -382,4 +381,5 @@
    endsw
 endif
+
 
 echo "apres les opts dim $dim"
@@ -414,4 +414,5 @@
 #subtilites sur le nom de la librairie
 ########################################################################
+
 
 \rm tmp ; touch tmp
@@ -644,4 +645,5 @@
 #  Execution de la comande make
 ########################################################################
+
 
 echo PHYSIQUE $phys
@@ -780,4 +782,5 @@
 cd $localdir
 
+
 echo $make -f $LMDGCM/makefile \
 OPTION_DEP="$opt_dep" OPTION_LINK="$opt_link" \
Index: /trunk/LMDZ.GENERIC/makegcm_pgf90
===================================================================
--- /trunk/LMDZ.GENERIC/makegcm_pgf90	(revision 252)
+++ /trunk/LMDZ.GENERIC/makegcm_pgf90	(revision 253)
@@ -6,5 +6,5 @@
 ########################################################################
 set dim="64x48x32"
-set physique=mars
+set physique=std
 set phys="PHYS=$physique"
 set include='-I$(LIBF)/grid -I$(LIBF)/bibio -I.'
@@ -13,23 +13,22 @@
 set grille=reg
 set dyntype="dyn"
+set bands="32x36"
 ########################################################################
 # path a changer contenant les sources et les objets du modele
 ########################################################################
 
-###### VERSION LMDZ.3.3
-# set LMDGCM=$HOME/LMDZ.3.3
-#
-
 #### If you want you can set environment variables here
-#setenv LMDGCM /d5/emlmd/test_universal/LMDZ.UCM.v0.2
+#setenv LMDGCM "/san/home/rdword/gcm/LMDZ.GENERIC"
 #setenv LIBOGCM $LMDGCM/libo
-#if ( `uname -m` == "x86_64" ) then
-## 64 bit machines
-#  setenv NCDFLIB /donnees/emlmd/netcdf64-4.0.1_pgi/lib
-#  setenv NCDFINC /donnees/emlmd/netcdf64-4.0.1_pgi/include
-#else
-#  setenv NCDFLIB /distrib/local/netcdf/pgi_32bits/lib
-#  setenv NCDFINC /distrib/local/netcdf/pgi_32bits/include
-#endif
+#setenv NCDFLIB /usr/local/lib
+#setenv NCDFINC /usr/local/include
+if ( `uname -m` == "x86_64" ) then
+# 64 bit machines
+  setenv NCDFLIB /donnees/emlmd/netcdf64-4.0.1_pgi/lib
+  setenv NCDFINC /donnees/emlmd/netcdf64-4.0.1_pgi/include
+else
+  setenv NCDFLIB /donnees/emlmd/netcdf-4.0.1_pgi/lib
+  setenv NCDFINC /donnees/emlmd/netcdf-4.0.1_pgi/include
+endif
 ####
 
@@ -179,12 +178,17 @@
 else if $DEC then
 else if $LINUX then
-   set optim90=" -fast"
-   set optimtru90=" -fast -c -Mfree "
-#   set opt_link=" -Mfree -L/usr/local/pgi/linux86/lib -lpgf90 -lpgftnrtl -lpghpf -lpghpf2 -L$NCDFLIB -lnetcdf -Wl,-Bstatic "
-# Ehouarn: there is no /usr/local/pgi/linux86/lib, but it doesn't matter
-#          also changed -Wl,-Bstatic to -Bstatic
-   set opt_link=" -Mfree -lpgf90 -lpgftnrtl -lpghpf -lpghpf2 -L$NCDFLIB -lnetcdf -Bstatic "
+   set optim=" -O2 -Munroll -Mcache_align "
+   set optim90=" -O2 -Munroll -Mcache_align "
+   set optimtru90=" -O2 -Munroll -Mcache_align "
+   set opt_link=" -L$NCDFLIB -lnetcdf"
    set mod_loc_dir=$localdir
    set mod_suffix=mod
+# Ehouarn 'ifort' compiler
+#   #NB: on gnome -O3 ==> NaNs ...
+#   set optim=" -O2 -ip -mkl=sequential -align common "
+#   set optim90=" -O2 -ip -mkl=sequential -align common "
+#   set optimtru90=" -O2 -ip -mkl=sequential -align common "
+#   set mod_loc_dir=$LIBOGCM
+#   set mod_suffix=mod
 else if $NEC then
    set optim90=' -clear -C hopt -float0 -ew -P static -Wf,"-pvctl fullmsg noassume "'
@@ -335,9 +339,9 @@
 ########################################################################
 
-    case -d:
+    case -d
         set dim=$2 ; shift ; shift ; goto top
                         
     case -O:
-        set optim90="$2" ; shift ; shift ; goto top
+        set optim90="$2" ; set optim="$2" ; set optimtru90="$2" ; shift ; shift ; goto top
 
      case -p
@@ -347,4 +351,7 @@
         set grille="$2" ; shift ; shift ; goto top
 
+    case -b
+        set bands=$2 ; shift ; shift ; goto top
+           
      case -t
         set ntrac=$2 ; shift ; shift ; goto top
@@ -375,5 +382,10 @@
            set optim90="$optim90"" -G1 "
         else if $LINUX then
-           set optim90="-g -Mbounds "
+           set optim="-g -Mbounds -Kieee -Ktrap=fp -traceback"
+           set optim90="-g -Mbounds -Kieee -Ktrap=fp -traceback"
+           set optimtru90="-g -Mbounds -Kieee -Ktrap=fp -traceback"
+#	   set optim=" -g -no-ftz -traceback -ftrapuv -fp-stack-check "
+#           set optim90=" -g -no-ftz -traceback -ftrapuv -fp-stack-check "
+#           set optimtru90=" -g -no-ftz -traceback -ftrapuv -fp-stack-check "
         else 
            echo "pas d option debug predefinie pour cette machine"
@@ -387,4 +399,5 @@
    endsw
 endif
+
 
 echo "apres les opts dim $dim"
@@ -420,4 +433,5 @@
 ########################################################################
 
+
 \rm tmp ; touch tmp
 \rm tmp90 ; touch tmp90
@@ -437,5 +451,4 @@
 
 # dimension
-
 echo "dimension avant sed $dim"
 if ( $IBM ) then
@@ -446,9 +459,21 @@
    set dim_=`echo $dim | sed -e 's/[^0-9]/_/g'`
 else
-#   set dim=`echo $dim | sed -n -e 's/[^0-9]/ /gp'`
-#   set dim_=`echo $dim | sed -n -e 's/[^0-9]/_/gp'`
      set dim=`echo $dim | sed -e 's/[^0-9]/ /g'`
      set dim_=`echo $dim | sed -e 's/[^0-9]/_/g'`
 endif
+
+# bands
+echo "bands avant sed $bands"
+if ( $IBM ) then
+   set bands=`echo $bands | sed -en 's/[^0-9]/ /g'`
+   set bands_=`echo $bands | sed -en 's/[^0-9]/_/g'`
+else if ( $SUN || $XNEC ) then
+   set bands=`echo $bands | sed -e 's/[^0-9]/ /g'` 
+   set bands_=`echo $bands | sed -e 's/[^0-9]/_/g'`
+else
+     set bands=`echo $bands | sed -e 's/[^0-9]/ /g'`
+     set bands_=`echo $bands | sed -e 's/[^0-9]/_/g'`
+endif
+
 
 # build final name of libraries directory:
@@ -458,4 +483,7 @@
   set nomlib=${nomlib}_${dim_}_t${ntrac}_${grille}
 endif
+
+# Append number of bands to nomlib (new for universal model)
+set nomlib=${nomlib}_${bands_}
 
 # Append 'physique' type, if it is not mars, to nomlib
@@ -502,12 +530,18 @@
 cd $libf/grid
 if ( -f dimensions.h ) then
-  echo "ATTENTION: vous etes sans doute en train de compiler le modele par ailleurs"
-  echo "Attendez que la premiere compilation soit terminee pour relancer la suivante."
-  echo "Si vous etes sur que vous ne compilez pas le modele par ailleurs,"
-  echo "vous pouvez continuer en repondant oui."
-  echo "Voulez-vous vraiment continuer?"
-  if ( $< == "oui" ) then
+  echo "WARNING: you are already compiling the model somewhere else"
+  echo "Wait until the first compilation is finished before starting."
+  echo "If you are sure that you are not compiling elsewhere, you can"
+  echo "type [yes] to continue."
+  echo "Do you want to continue?"
+#  echo "ATTENTION: vous etes sans doute en train de compiler le modele par ailleurs"
+#  echo "Attendez que la premiere compilation soit terminee pour relancer la suivante."
+#  echo "Si vous etes sur que vous ne compilez pas le modele par ailleurs,"
+#  echo "vous pouvez continuer en repondant oui."
+#  echo "Voulez-vous vraiment continuer?"
+  if ( $< == "yes" ) then
     #remove old dimensions.h file
     \rm $libf/grid/dimensions.h
+    \rm $libf/grid/bands.h
   else
     exit
@@ -520,4 +554,9 @@
 # echo contents of dimensions.h to standard output
 cat $libf/grid/dimensions.h
+
+# Build the appropriate 'bands.h' file
+makbands $bands
+# echo contents of bands.h to standard output
+cat $libf/grid/bands.h
 
 cd $LMDGCM
@@ -552,18 +591,17 @@
 #   Traitement special pour le nouveau rayonnement de Laurent Li.
 ######################################################################
-
-if ( -f $libf/phy$physique/raddim.h ) then
-  if ( -f $libf/phy$physique/raddim.$dimh.h ) then
-    \rm $libf/phy$physique/raddim.h
-    cp -p $libf/phy$physique/raddim.$dimh.h $libf/phy$physique/raddim.h
-    echo $libf/phy$physique/raddim.$dimh.h 
-    cat $libf/phy$physique/raddim.$dimh.h 
-    cat $libf/phy$physique/raddim.h
-  else
-    echo On peut diminuer la taille de l executable en creant
-    echo le fichier $libf/phy$physique/raddim.$dimh.h
-    \cp -p $libf/phy$physique/raddim.defaut.h $libf/phy$physique/raddim.h
-  endif
-endif
+#if ( -f $libf/phy$physique/raddim.h ) then
+#  if ( -f $libf/phy$physique/raddim.$dimh.h ) then
+#    \rm $libf/phy$physique/raddim.h
+#    cp -p $libf/phy$physique/raddim.$dimh.h $libf/phy$physique/raddim.h
+#    echo $libf/phy$physique/raddim.$dimh.h 
+#    cat $libf/phy$physique/raddim.$dimh.h 
+#    cat $libf/phy$physique/raddim.h
+#  else
+#    echo On peut diminuer la taille de l executable en creant
+#    echo le fichier $libf/phy$physique/raddim.$dimh.h
+#    \cp -p $libf/phy$physique/raddim.defaut.h $libf/phy$physique/raddim.h
+#  endif
+#endif
 
 ######################################################################
@@ -612,5 +650,5 @@
         \cp tmp77 liste_des_sources_f77
         \cp tmp90 liste_des_sources_f90
-        echo "On recree le makefile"
+        echo "Remaking the makefile!"
         if ("$dyntype" == "olddyn") then
           ./create_make_gcm olddyn3d grid bibio phy$physique >! tmp
@@ -619,5 +657,5 @@
         endif
         \mv tmp makefile
-        echo "Nouveau makefile cree."
+        echo "New makefile created."
 endif
 
@@ -625,4 +663,5 @@
 #  Execution de la comande make
 ########################################################################
+
 
 echo PHYSIQUE $phys
@@ -643,4 +682,7 @@
    set f90=f90
 else if $LINUX then
+#   set f77=ifort
+#   set f90=ifort
+#   set opt_link=" -L$LIBOGCM -L$NCDFLIB -lnetcdf "
    set f77=pgf90
    set f90=pgf90
@@ -704,15 +746,15 @@
 # l'optimisation de startvar se passe mal
 #
-if ($code == 'create_etat0' && $VPP) then
-   if ( ! -f $libo/libdyn3d.a ) then
-     echo "Priere de compiler gcm en premier pour des raisons d'optimisation"
-     \rm $libf/grid/dimensions.h                                             
-     exit                       
-   endif
-   set optim90="$optim90"" -X9 -w"
-   set opt_link="-L$NCDFLIB -lnetcdf"
-   touch $LMDGCM/libf/dyn3d/startvar.F
-   touch $LMDGCM/libf/dyn3d/etat0_netcdf.F
-endif
+#if ($code == 'create_etat0' && $VPP) then
+#   if ( ! -f $libo/libdyn3d.a ) then
+#     echo "Priere de compiler gcm en premier pour des raisons d'optimisation"
+#     \rm $libf/grid/dimensions.h                                             
+#     exit                       
+#   endif
+#   set optim90="$optim90"" -X9 -w"
+#   set opt_link="-L$NCDFLIB -lnetcdf"
+#   touch $LMDGCM/libf/dyn3d/startvar.F
+#   touch $LMDGCM/libf/dyn3d/etat0_netcdf.F
+#endif
 
 #
@@ -738,4 +780,8 @@
  set optimtru90=" $optimtru90 -I$libo "
 else if $LINUX then
+# set optim="$optim -I${libo}"
+# set optim90="$optim90 -I${libo}"
+# set optimtru90="$optimtru90 -ffree-form -I${libo}"
+ set optim="$optim -module $libo"
  set optim90="$optim90 -module $libo"
  set optimtru90="$optimtru90 -module $libo"
@@ -757,6 +803,8 @@
 cd $localdir
 
+
 echo $make -f $LMDGCM/makefile \
 OPTION_DEP="$opt_dep" OPTION_LINK="$opt_link" \
+OPTIM="$optim" \
 OPTIM90="$optim90" \
 OPTIMTRU90="$optimtru90" \
@@ -783,4 +831,5 @@
 $make -f $LMDGCM/makefile \
 OPTION_DEP="$opt_dep" OPTION_LINK="$opt_link" \
+OPTIM="$optim" \
 OPTIM90="$optim90" \
 OPTIMTRU90="$optimtru90" \
@@ -805,2 +854,3 @@
 
 \rm $libf/grid/dimensions.h
+\rm $libf/grid/bands.h
Index: /trunk/LMDZ.GENERIC/tmp
===================================================================
--- /trunk/LMDZ.GENERIC/tmp	(revision 252)
+++ /trunk/LMDZ.GENERIC/tmp	(revision 253)
@@ -1,1 +1,5 @@
-fast
+O2
+ip
+mklsequential
+align
+common
Index: /trunk/LMDZ.GENERIC/tmp77
===================================================================
--- /trunk/LMDZ.GENERIC/tmp77	(revision 252)
+++ /trunk/LMDZ.GENERIC/tmp77	(revision 253)
@@ -179,34 +179,37 @@
 libf/filtrez/jacobi.F
 libf/filtrez/parafilt.h
-libf/grid/fxyprim.h
 libf/grid/fxy_new.h
 libf/grid/fxy_reg.h
 libf/grid/fxy_sin.h
+libf/grid/fxyprim.h
 libf/grid/dimensions.h
 libf/grid/bands.h
 libf/phystd/aerave.F
+libf/phystd/aerave_new.F
 libf/phystd/blackl.F
-libf/phystd/physiq.F
-libf/phystd/callcorrk.F
-libf/phystd/tracer.h
 libf/phystd/callkeys.h
+libf/phystd/callsedim.F
 libf/phystd/comcstfi.h
-libf/phystd/cvmgp.F
 libf/phystd/comdiurn.h
 libf/phystd/comg1d.h
 libf/phystd/comgeomfi.h
-libf/phystd/solarlong.F
 libf/phystd/comsaison.h
+libf/phystd/comsoil.h
 libf/phystd/convadj.F
+libf/phystd/cpdet.F
+libf/phystd/cpdet.h
+libf/phystd/cvmgp.F
 libf/phystd/cvmgt.F
-libf/phystd/lagrange.F
 libf/phystd/datafile.h
 libf/phystd/datareadnc.F
 libf/phystd/dimphys.h
-libf/phystd/tabfi.F
+libf/phystd/dsolver.F
+libf/phystd/dtridgl.F
+libf/phystd/evap.F
 libf/phystd/fisice.h
-libf/phystd/optcv.F
-libf/phystd/phyetat0.F
-libf/phystd/planete.h
+libf/phystd/forceWCfn.F
+libf/phystd/gases.h
+libf/phystd/gfluxi.F
+libf/phystd/gfluxv.F
 libf/phystd/inifis.F
 libf/phystd/iniorbit.F
@@ -214,43 +217,41 @@
 libf/phystd/initracer.F
 libf/phystd/iniwrite.F
+libf/phystd/iniwrite_spec.F
+libf/phystd/interp_line.F
 libf/phystd/ismax.F
 libf/phystd/ismin.F
-libf/phystd/physdem1.F
+libf/phystd/lagrange.F
+libf/phystd/largescale.F
 libf/phystd/mucorr.F
 libf/phystd/mufract.F
 libf/phystd/multipl.F
+libf/phystd/newsedim.F
+libf/phystd/orbite.F
+libf/phystd/phyetat0.F
+libf/phystd/physdem1.F
+libf/phystd/planete.h
+libf/phystd/profile.F
+libf/phystd/rcm1d.F
+libf/phystd/scopyi.F
+libf/phystd/sfluxi.F
 libf/phystd/sfluxv.F
-libf/phystd/orbite.F
-libf/phystd/profile.F
-libf/phystd/scopyi.F
+libf/phystd/soil.F
+libf/phystd/soil_settings.F
+libf/phystd/statto.h
+libf/phystd/stelang.F
+libf/phystd/stellarlong.F
+libf/phystd/surface_nature.F
+libf/phystd/surfdat.h
 libf/phystd/surfini.F
+libf/phystd/tabfi.F
+libf/phystd/tpindex.F
+libf/phystd/tracer.h
 libf/phystd/vdifc.F
-libf/phystd/soil.F
-libf/phystd/solang.F
-libf/phystd/statto.h
-libf/phystd/surfdat.h
 libf/phystd/vdif_cd.F
 libf/phystd/vdif_kc.F
 libf/phystd/vlz_fi.F
 libf/phystd/watercap.h
-libf/phystd/comsoil.h
 libf/phystd/writediagfi.F
+libf/phystd/writediagspec.F
 libf/phystd/writeg1d.F
 libf/phystd/zerophys.F
-libf/phystd/callsedim.F
-libf/phystd/interp_line.F
-libf/phystd/soil_settings.F
-libf/phystd/sfluxi.F
-libf/phystd/tpindex.F
-libf/phystd/gfluxv.F
-libf/phystd/gfluxi.F
-libf/phystd/dsolver.F
-libf/phystd/dtridgl.F
-libf/phystd/co2snow.F
-libf/phystd/testphys1d.F
-libf/phystd/kastprof_fn.F
-libf/phystd/newsedim.F
-libf/phystd/aerave_new.F
-libf/phystd/iniwrite_spec.F
-libf/phystd/writediagspec.F
-libf/phystd/largescale2.F
Index: /trunk/LMDZ.GENERIC/tmp90
===================================================================
--- /trunk/LMDZ.GENERIC/tmp90	(revision 252)
+++ /trunk/LMDZ.GENERIC/tmp90	(revision 253)
@@ -3,27 +3,38 @@
 libf/bibio/ioipsl_stringop.F90
 libf/phystd/aeropacity.F90
+libf/phystd/aeroptproperties.F90
+libf/phystd/ave_stelspec.F90
+libf/phystd/calc_cpp3d.F90
+libf/phystd/calc_cpp_mugaz.F90
+libf/phystd/calc_rayleigh.F90
+libf/phystd/callcorrk.F90
+libf/phystd/condens_co2cloud.F90
+libf/phystd/def_var.F90
+libf/phystd/hydrol.F90
+libf/phystd/iniwritesoil.F90
+libf/phystd/interpolateH2H2.F90
+libf/phystd/kastprof_fn.F90
+libf/phystd/mkstat.F90
+libf/phystd/moistadj.F90
+libf/phystd/N2broadprof_fn.F90
+libf/phystd/newtrelax.F90
+libf/phystd/optci.F90
+libf/phystd/optcv.F90
+libf/phystd/physiq.F90
+libf/phystd/radcommon_h.F90
+libf/phystd/radinc_h.F90
+libf/phystd/rain.F90
+libf/phystd/setspi.F90
+libf/phystd/setspv.F90
+libf/phystd/simpleprof_fn.F90
+libf/phystd/stokes.F90
 libf/phystd/suaer_corrk.F90
-libf/phystd/radcommon_h.F90
-libf/phystd/condens_co2cloud.F90
 libf/phystd/sugas_corrk.F90
-libf/phystd/def_var.F90
-libf/phystd/rain.F90
-libf/phystd/radinc_h.F90
-libf/phystd/optci.F90
-libf/phystd/mkstat.F90
-libf/phystd/setspi.F90
-libf/phystd/aeroptproperties.F90
-libf/phystd/stokes.F90
-libf/phystd/setspv.F90
+libf/phystd/su_gases.F90
+libf/phystd/su_watercycle.F90
+libf/phystd/totalcloudfrac.F90
 libf/phystd/watercommon_h.F90
+libf/phystd/watersat.F90
+libf/phystd/watersat_grad.F90
+libf/phystd/writediagsoil.F90
 libf/phystd/wstats.F90
-libf/phystd/iniwritesoil.F90
-libf/phystd/writediagsoil.F90
-libf/phystd/su_watercycle.F90
-libf/phystd/aeroptpropertiesJBnew.F90
-libf/phystd/watersat_2.F90
-libf/phystd/moistadj.F90
-libf/phystd/watersat_grad.F90
-libf/phystd/ave_stelspec.F90
-libf/phystd/calc_rayleigh.F90
-libf/phystd/calc_cpp3d.F90
Index: /trunk/LMDZ.GENERIC/utilities/clean_bad_run
===================================================================
--- /trunk/LMDZ.GENERIC/utilities/clean_bad_run	(revision 253)
+++ /trunk/LMDZ.GENERIC/utilities/clean_bad_run	(revision 253)
@@ -0,0 +1,33 @@
+#!/bin/bash
+
+mv start_archive.nc ../
+rm -f gcm_*
+rm -f fort*
+rm -f g1d.dat
+rm -f g1d.ctl
+rm -f exe_planet
+rm -f lruns?
+rm -f lrun*
+rm -f olr.txt
+rm -f olr?.txt
+rm -f start.nc
+rm -f start*.nc
+rm -f startfi.nc
+rm -f startfi*.nc
+rm -f stats*.nc
+rm -f diagfi.nc
+rm -f diagfi*.nc
+rm -f diagspec.nc
+rm -f diagspec*.nc
+rm -f *.out
+rm -f num_run
+rm -f num_run.crash
+rm -f gcm_3D.*
+rm -f rcm_1D.*
+rm -f *~
+rm -rf files_out
+rm -f profile*.out
+mv ../start_archive.nc .
+
+
+exit 0
Index: /trunk/LMDZ.GENERIC/utilities/co2_cont.for
===================================================================
--- /trunk/LMDZ.GENERIC/utilities/co2_cont.for	(revision 253)
+++ /trunk/LMDZ.GENERIC/utilities/co2_cont.for	(revision 253)
@@ -0,0 +1,346 @@
+c     This program computes RT CIA spectra of CO2 at low density limit 
+C     at temperatures between 200 and 800K.
+C     
+C     ============================================================================
+C     Copyright (C) 1997   Marcin Gruszka 
+C     ============================================================================
+C     
+C     Copyright Notice:
+C     You may use this program for your scientific applications,
+C     but please do not	distribute it yourself.
+C     Direct all your inquires to the  author: e-mail aborysow@stella.nbi.dk
+C     Final request: If you publish  your work which benefited from this
+C     program, please acknowledge using this program and quote 
+C     the original paper describing the procedure:
+C     M. Gruszka and A. Borysow,
+C     Roto-translational collision-induced absorption of CO2
+C     for the Atmosphere of Venus at Frequencies from 0 to 250 cm$^{-1}$
+C     and at temperature from 200K to 800K,
+C     Icarus, vol. 129, pp. 172-177, (1997). 
+
+C     
+C     The paper (Icarus) describing this computer model, is based on  original paper by
+C     M. Gruszka and A. Borysow,
+C     "Computer Simulation of the Far Infrared Collision-induced absorption spectra 
+C     of gaseous CO2", Mol. Phys., vol. 93, pp. 1007-1016, 1998. 
+C     ============================================================================
+C     
+C     NOTE: The program gives data at spacing corresponding to
+c     Freq(max)-Freq(min)/(npoint-1),
+c     Since reasons are unknown (author's secret), it is recommended to
+c     request one more point that neccesary and get the right freq. step
+c     ==================================================================
+
+c     
+c     The following input parametres are required (*):
+c     ------------------------------------------------
+c     (*) some input parameters are Fortran REAL numbers
+c     and should be entered with a decimal point,
+c     not like INTEGER!
+c     
+c     1. Temperature: (in K) (REAL)
+c     -the model is restricted to the temperature range from
+c     200 K to 800 K.
+c     
+c     2. Frequency limits: (in cm^-1) (REAL,REAL)
+c     -the model has been designed to reproduce the MD and the
+c     experimental data up to 250 cm^-1. There is no restriction
+c     on requesting a higher value, but the accuracy may decrease 
+c     significantly.
+c     
+c     3. Number of points in the output file: (less than Npmx) (INTEGER)
+c     -the frequency grid is controled by the number of points
+c     in the output file.
+c     (i.e. if the upper limit = 250.0 and the number of points = 50.0,
+c     the spectrum will be computed every 5 cm^-1 )
+c     
+c     4. The output in automaticaly directed to output.dat file.
+c     
+c     STRUCTURE OF THE PROGRAM:
+c     -------------------------------------------------------------- 
+c     The MAIN program consists of three modules:
+c     
+c     1. getdat - provides the user interface, 
+c     in this subroutine the Temperature, Frequency Limits and
+c     the number of points are read from the keyboard.
+c     
+c     2. getspc - the main subroutine, where the spectrum is computed.
+c     The three input parameters (temp, range and n; all REAL numbers)
+c     are transmited by value and the absorption coefficient abcoef(..) 
+c     is returned. The default lenght of abcoef(..) is Npmx and if 
+c     n < Npmx, the empty places are set to 0. If a denser grid is
+c     required please change the n appropriaetly in the data declaration
+c     of the MAIN program and inside the getspc.
+c     
+c     3. putdat - generates the output file.
+c     The frequency (in cm^-1) and 
+c     the absorption coefficient (in cm^-1 amagat^-2) are written
+c     to the 'output.dat' file in the followinf format:
+c     format(f10.3,e20.7)
+c     
+c===========================================================================
+c     
+c     
+c     ---------------------------------------------------------------------------------------------------------------
+c     2008/10/15
+c     
+c     Modifications of the code by V. Eymet as follows:
+c     + only the "getspc" routine remains
+c     + inputs: temp (temperature in K), wn (wavenumber in cm^-1); output: abcoef (absorption coefficient, in cm^-1 amagat^-2)
+c     ---------------------------------------------------------------------------------------------------------------
+c
+c
+c
+c     ---------------------------------------------------------------------------------------------------------------
+c     2009/2/28
+c     
+c     Modifications of the code by R. Wordsworth as follows:
+c     + "baranov" routine added to calculate CIA dimer spectrum between 1100 and 1600 cm^-1
+c     + this uses recorded data rather than an analytical function, so bilinear interpolation is needed
+c     + inputs and outputs are identical to those of getspc
+c     ---------------------------------------------------------------------------------------------------------------
+
+
+
+      subroutine getspc(temp,wn,abcoef) ! computes the spectrum
+      implicit none
+      real*8 temp               !temperature
+      real*8 wn        !wavenumber
+      real*8 abcoef       !absorption coefficient
+c     -------------------------------------------------------
+c     The A, B and C parameters as given in the paper:
+      integer ndeg
+      parameter (ndeg=3)
+      real*8 ah(ndeg),bh(ndeg),at(ndeg),bt(ndeg),gam(ndeg)
+c     tau^{L}_{1}:
+      data ah /0.1586914382D+13,-0.9344296879D+01,0.6943966881D+00/
+c     tau^{L}_{2}:
+      data bh /0.1285676961D-12,0.9420973263D+01,-0.7855988401D+00/
+c     tau^{H}_{1}:
+      data at /0.3312598766D-09,0.7285659464D+01,-0.6732642658D+00/
+c     tau^{H}_{2}:
+      data bt /0.1960966173D+09,-0.6834613750D+01,0.5516825232D+00/
+c     gamma_{1}:
+      data gam /0.1059151675D+17,-0.1048630307D+02, 0.7321430968D+00/
+c     **************************************************************
+c     The S - shape function parameters:
+      real*8 w1,w2
+      data w1,w2 /50.0d0, 100.0d0/
+c     --------------------------------------------------------------
+c     local variables:
+c     ----------------------------------
+      real*8 incrmt
+      integer p1,p2,n
+      real*8 a1,b1,a2,b2,gamma
+      real*8 bc1,bc2,bcbc
+      real*8 scon,mtot,spunit,gm0con
+      real*8 icm, frq, lntemp
+      real*8 xk1,x1,x2
+      external xk1
+      incrmt=250.0D+0
+      n=1
+      p1=idint(dnint(w1/incrmt))
+      p2=idint(dnint(w2/incrmt))
+      lntemp=dlog(temp)
+      a1=1.0d0/(ah(1)*dexp(ah(2)*lntemp+ah(3)*lntemp*lntemp))
+      b1=bh(1)*dexp(bh(2)*lntemp+bh(3)*lntemp*lntemp)
+      a2=1.0d0/(at(1)*dexp(at(2)*lntemp+at(3)*lntemp*lntemp))
+      b2=bt(1)*dexp(bt(2)*lntemp+bt(3)*lntemp*lntemp)
+      gamma=gam(1)*dexp(gam(2)*lntemp+gam(3)*lntemp*lntemp)
+      icm=0.1885d0
+      frq=wn
+      x1=b1*dsqrt(a1*a1+icm*icm*frq*frq)
+      bc1=dexp(a1*b1)*a1*XK1(x1)/(a1*a1+icm*icm*frq*frq)
+      x2=b2*dsqrt(a2*a2+icm*icm*frq*frq)
+      bc2=dexp(a2*b2)*a2*XK1(x2)/(a2*a2+icm*icm*frq*frq)
+      if (p1.ge.1) then
+         bcbc=bc1
+      else if (p2.lt.1) then
+         bcbc=bc2
+      else
+         bcbc=dexp( (1.0d0-dble(1-p1)/dble(p2-p1))*dlog(bc1)+
+     &        dble(1-p1)/dble(p2-p1)*dlog(bc2) )
+      endif
+      spunit=1.296917d55
+      gm0con=1.259009d-6
+      scon=spunit/temp
+      mtot=gm0con*temp*gamma*1.0d-56
+      frq=wn
+      abcoef=scon*mtot*bcbc*frq*frq
+      return
+      end
+c     
+c     
+      FUNCTION XK1(X)
+C     MODIFIED BESSEL FUNCTION K1(X) TIMES X
+C     PRECISION IS BETTER THAN 2.2e-7 EVERYWHERE.
+C     ABRAMOWITZ AND S,TEGUN, P.379; TABLES P.417.
+      implicit double precision (a-h,o-z)
+!      IF(X-2.) 10,10,20
+      IF(X-2..le.0.0)then
+! 10   T=(X/3.75)**2
+      T=(X/3.75)**2
+      FI1=X*((((((.00032411*T+.00301532)*T+.02658733)*T+.15084934)
+     1     *T+.51498869)*T+.87890594)*T+.5)
+      T=(X/2.)**2
+      P=(((((-.00004686*T-.00110404)*T-.01919402)*T-.18156897)*T-
+     1     .67278579)*T+.15443144)*T+1.
+      XK1=X*dLOG(X/2)*FI1+P
+!      RETURN
+      else
+! 20   T=2./X
+      T=2./X
+      P=(((((-.00068245*T+.00325614)*T-.00780353)*T+.01504268)*T-
+     1     .03655620)*T+.23498619)*T+1.25331414
+      X=dMIN1(X,330.d0)
+      XK1=dSQRT(X)*dEXP(-X)*P
+      endif
+      RETURN
+      END
+
+
+
+
+c     ----------------------------------------------------------------------------------------------
+c     Added by RDW for inclusion of Baranov (2004) data
+      subroutine baranov(temp,wn,abcoef)
+      ! computes the dimer spectrum
+
+      implicit none
+      real*8 temp               !temperature
+      real*8 wn                 !wavenumber
+      real*8 abcoef             !absorption coefficient
+
+      integer nS,nT
+!      parameter(nS=1713)
+      parameter(nS=3000)
+      parameter(nT=9)
+
+      real*8 wn_arr(nS)
+      real*8 temp_arr(nT)
+      real*8 dim_arr(nS,nT)
+
+      integer pop
+      logical firstcall
+
+      save wn_arr, temp_arr, dim_arr
+
+      character*100 dt_file
+      integer strlen,ios
+      character*100 label
+      label='subroutine baranov'
+
+      dt_file='/san/home/rdword/kspectrum/line_data/CO2_dimer_data_NEW'
+!      dt_file='./data/CO2_dimer_data'
+      open(33,file=dt_file(1:strlen(dt_file)),
+     &     form='unformatted',
+     &     status='old',iostat=ios)
+      if (ios.ne.0) then        ! file not found
+         write(*,*) 'Error from ',label(1:strlen(label)),' :'
+         write(*,*) 'Data file could not be found:'
+         write(*,*) dt_file(1:strlen(dt_file))
+         stop
+      else
+         read(33) wn_arr
+         read(33) temp_arr
+         read(33) dim_arr
+      endif
+      close(33)
+
+
+!	print*,wn_arr(1)!
+!	print*,wn_arr(3000)
+!	print*,temp_arr
+!	print*,dim_arr(1500,1)
+!	stop
+
+
+      call bilinear(wn_arr,temp_arr,nS,nT,dim_arr,wn,temp,abcoef)
+
+ 111  continue
+      return
+      end
+c     ----------------------------------------------------------------------------------------------
+
+c     ----------------------------------------------------------------------------------------------
+c     Added by RDW for inclusion of Baranov (2004) data
+      subroutine bilinear(x_arr,y_arr,nX,nY,f2d_arr,x,y,f)
+
+      implicit none
+
+      integer nX,nY,i,j,a,b
+
+      real*8 x,y,x1,x2,y1,y2
+      real*8 f,f11,f12,f21,f22,fA,fB
+      real*8 x_arr(nX)
+      real*8 y_arr(nY)
+      real*8 f2d_arr(nX,nY)
+      
+      integer strlen
+      character*100 label
+      label='subroutine bilinear'
+
+c     1st check we're within the wavenumber range
+      if ((x.lt.x_arr(2)).or.(x.gt.x_arr(nX-2))) then
+         f=0.0D+0
+c     print*,'x=',x,x_Arr(2),x_arr(nX-2)
+c     stop('Outside CIA dimer wavenumber range!\n')
+         goto 112
+      else
+         
+c     in the x (wavenumber) direction 1st
+         i=1
+ 10      if (i.lt.(nX+1)) then ! what passes for a 'while' loop in this sorry language...
+            if (x_arr(i).gt.x) then
+               x1=x_arr(i-1)
+               x2=x_arr(i)
+               a=i-1
+               i=9999
+            endif
+            i=i+1
+            goto 10
+         endif
+      endif
+      
+      if ((y.lt.y_arr(1)).or.(y.gt.y_arr(nY))) then
+         write(*,*) 'Error from ',label(1:strlen(label)),' :'
+         write(*,*) 'Outside CIA dimer temperature range!'
+         if(y.lt.y_arr(1))then
+            y=y_arr(1)+0.01
+         endif
+         if(y.gt.y_arr(nY))then
+            y=y_arr(nY)-0.01
+         endif
+!         stop
+      else
+c     in the y (temperature) direction 2nd
+         j=1
+ 20      if (j.lt.(nY+1)) then
+            if (y_arr(j).gt.y) then
+               y1=y_arr(j-1)
+               y2=y_arr(j)
+               b=j-1
+               j=9999
+            endif
+            j=j+1
+            goto 20
+         endif
+      endif
+      
+      f11=f2d_arr(a,b)
+      f21=f2d_arr(a+1,b)
+      f12=f2d_arr(a,b+1)
+      f22=f2d_arr(a+1,b+1)
+      
+c     1st in x-direction
+      fA=f11*(x2-x)/(x2-x1)+f21*(x-x1)/(x2-x1)
+      fB=f12*(x2-x)/(x2-x1)+f22*(x-x1)/(x2-x1)
+      
+c     then in y-direction
+      f=fA*(y2-y)/(y2-y1)+fB*(y-y1)/(y2-y1)
+      
+ 112  continue
+      return
+      end
+c     ----------------------------------------------------------------------------------------------
+      
Index: /trunk/LMDZ.GENERIC/utilities/compile
===================================================================
--- /trunk/LMDZ.GENERIC/utilities/compile	(revision 253)
+++ /trunk/LMDZ.GENERIC/utilities/compile	(revision 253)
@@ -0,0 +1,11 @@
+#!/bin/bash
+#gfortran -c -g -fbounds-check generate_kmatrix.F90 strlen.for
+
+gfortran -c generate_kmatrix.F90 co2_cont.for strlen.for
+gfortran -o generate_kmatrix.exe generate_kmatrix.o co2_cont.o strlen.o
+
+gfortran -c make_composition_gen.for strlen.for
+gfortran -o make_composition_gen.exe make_composition_gen.o strlen.o
+
+rm -f *o
+rm -f *~
